local _addon = WYK_Toolbar

_addon.Feature.Toolbar.GetHorse = function() 
	local style = _addon:GetOrDefault( "Countdown", _addon.Settings["horse_setting"])
	local useIcon = _addon:GetOrDefault( true, _addon.Settings["horse_icon"] )
	local TimeTilMountFeed, TotalTime = nil, nil
	for ii = 0, 10, 1 do
		if type(GetTimeUntilMountCanBeFed) == "function" then
			TimeTilMountFeed, TotalTime = GetTimeUntilMountCanBeFed(ii)
		else
			TimeTilMountFeed, TotalTime = GetTimeUntilCanBeTrained(ii)
		end
		if TimeTilMountFeed ~= nil and TotalTime ~= nil then break end
	end
	if useIcon then
		local o = wykkydsToolbar.Tools[_addon.G.BAR_TOOL_HORSE].Control
		if o.Icon == nil then o.Icon = _addon.Feature.Toolbar.MakeSpacerControl( o ); o.Icon:SetTexture( "/esoui/art/mounts/tabicon_mounts_up.dds" ) end
		o.IconSize = 24
		o.BufferSize = 28
		if not o.UseIcon then
			o.Icon:SetDimensions( o.IconSize, o.IconSize )
			o.Icon:ClearAnchors()
			o.Icon:SetAnchor( RIGHT, o, LEFT, -4, 0 )
			o.Icon:SetHidden(false)
			local aBool, aPoint, aTarget, aTargetPoint, aX, aY = o:GetAnchor()
			o.PreviousAnchor = {aPoint, aTarget, aTargetPoint, aX, aY}
			o:ClearAnchors()
			o:SetAnchor( aPoint, aTarget, aTargetPoint, aX + o.BufferSize, aY )
		end
		o.UseIcon = true
	else
		local o = wykkydsToolbar.Tools[_addon.G.BAR_TOOL_HORSE].Control
		if o.UseIcon == true then
			o.Icon:SetDimensions( o.IconSize, o.IconSize )
			o.Icon:ClearAnchors()
			o.Icon:SetAnchor( RIGHT, o, LEFT, -4, 0 )
			o.Icon:SetHidden(true)
			if o.PreviousAnchor ~= nil then
				o:ClearAnchors()
				o:SetAnchor( o.PreviousAnchor[1], o.PreviousAnchor[2], o.PreviousAnchor[3], o.PreviousAnchor[4], o.PreviousAnchor[5] )
			end
			o.PreviousAnchor = nil
		end
		o.UseIcon = false
	end
	if TimeTilMountFeed == nil or TotalTime == nil then return "None To Feed", { .65, .65, .65, 1 } end
	local r, g, b = _addon:GetColorScale_RedGreenPowerMeter(TimeTilMountFeed, TotalTime, true)
	local retVal, c = "", { r, g, b, 1 }
	local TimeForHuman = _addon:GetMillisecondsToHuman(TimeTilMountFeed, false)
	if TimeTilMountFeed == nil or TotalTime == nil then return retVal, c; end
	local hh, mm, ss = TimeForHuman:match("([^:]+):([^:]+):([^:]+)")
	local hn, mn, sn = tonumber(hh), tonumber(mm), tonumber(ss)
	if style == "Fancy" and type(GetTimeUntilMountCanBeFed) == "function" then
		if hn == 19 then retVal = "Bloated"
		elseif hn >= 18 then retVal = "Stuffed"
		elseif hn >= 16 then retVal = "Full"
		elseif hn >= 12 then retVal = "Pleased"
		elseif hn >= 8 then retVal = "Content"
		elseif hn >= 4 then retVal = "Unsettled"
		elseif hn >= 2 then retVal = "Snackish"
		elseif hn == 1 then retVal = "Expecting"
		else
			if mn >= 30 then retVal = "Hungry"
			elseif mn >= 15 then retVal = "Starving"
			elseif mn >= 1 then retVal = "Ravenous"
			else
				if sn >= 30 then retVal = "Ravenous"
				elseif sn >= 15 then retVal = "Malnutrition!"
				else
					retVal = "FEED ME!"	
				end
			end
		end
	elseif style == "Fancy" and type(GetTimeUntilMountCanBeFed) ~= "function" then
		if hn == 19 then retVal = "Learning"
		elseif hn >= 18 then retVal = "Memorizing"
		elseif hn >= 16 then retVal = "Absorbing"
		elseif hn >= 12 then retVal = "Practicing"
		elseif hn >= 8 then retVal = "Studying"
		elseif hn >= 4 then retVal = "Exhausted"
		elseif hn >= 2 then retVal = "Resting"
		elseif hn == 1 then retVal = "Sore"
		else
			if mn >= 30 then retVal = "Stretching"
			elseif mn >= 15 then retVal = "Flexing"
			elseif mn >= 1 then retVal = "Prepping"
			else
				if sn >= 30 then retVal = "Warm Up"
				elseif sn >= 15 then retVal = "Ready"
				else
					retVal = "TRAIN!"	
				end
			end
		end
	elseif style == "Descriptive" then
		if hn > 0 then retVal = hh .. " Hours" else
			if mn > 0 then retVal = mm .. " Minutes" else
				if sn > 0 then retVal = ss .. " Seconds" else
					if type(GetTimeUntilMountCanBeFed) ~= "function" then
						retVal = "TRAIN!"	
					else
						retVal = "FEED ME!"	
					end
				end
			end
		end
	elseif style == "Countdown" then
		retVal = TimeForHuman
	end
	return retVal, c
end
